# XQilla Simple API Documentation

# BaseInteractiveDebugger Class Reference

`#include <InteractiveDebugger.hpp>`

Inheritance diagram for BaseInteractiveDebugger:
[legend]

List of all members.

## Classes

struct | BreakPoint
struct | Continue
struct | Quit
struct | Run

## Public Member Functions

virtual | ~BaseInteractiveDebugger ()
unsigned int | setBreakPoint (const std::string &file, unsigned int line, unsigned int column, bool temporary)
bool | disableBreakPoint (unsigned int number)
bool | enableBreakPoint (unsigned int number)
void | listBreakPoints () const
void | setStep ()
void | setNext ()
bool | queryStarted () const
virtual void | run ()=0
virtual bool | changeFrame (unsigned int number)=0
virtual unsigned int | getStackSize () const =0
virtual void | stackTrace () const =0
virtual bool | outputCurrentFrame (unsigned int context=0) const =0
virtual void | outputCurrentFrameQueryPlan () const =0
virtual bool | queryCurrentFrame (const char *queryString) const =0
virtual bool | currentFrameLocation (std::string &file, unsigned int &line, unsigned int &column) const =0
virtual void | setDoLazyEvaluation (bool lazy)=0
virtual void | setDoFocusOptimizationsn (bool opt)=0
virtual void | setDoProjection (bool opt)=0

## Static Public Member Functions

static void | outputLocation (const XMLCh *file, unsigned int line, unsigned int column, unsigned int context=0)
static void | outputLocationFromString (const XMLCh *query, unsigned int line, unsigned int column, unsigned int context=0)
static std::string | regexFind (const char *regex, const std::string &str, int groupNo=1)

## Protected Member Functions

| BaseInteractiveDebugger ()
DebugCommand * | findCommand (std::string &command) const
void | checkBreak (bool entering)
void | breakForError (const char *message)
void | interrupted ()
void | readCommand ()

## Protected Attributes

std::vector< DebugCommand * > | commands_
DebugCommand * | prevcmd_
bool | queryStarted_
std::vector< BreakPoint > | breaks_
bool | step_
unsigned int | next_

## Constructor & Destructor Documentation

virtual BaseInteractiveDebugger::~BaseInteractiveDebugger | ( |  | ) | `[virtual]`

BaseInteractiveDebugger::BaseInteractiveDebugger | ( |  | ) | `[protected]`

## Member Function Documentation

void BaseInteractiveDebugger::breakForError | ( | const char * | message | ) | `[protected]`

virtual bool BaseInteractiveDebugger::changeFrame | ( | unsigned int | number | ) | `[pure virtual]`

void BaseInteractiveDebugger::checkBreak | ( | bool | entering | ) | `[protected]`

virtual bool BaseInteractiveDebugger::currentFrameLocation | ( | std::string & | file,
|  | unsigned int & | line,
|  | unsigned int & | column |
| ) |  |  | const`[pure virtual]`

bool BaseInteractiveDebugger::disableBreakPoint | ( | unsigned int | number | ) |

bool BaseInteractiveDebugger::enableBreakPoint | ( | unsigned int | number | ) |

DebugCommand* BaseInteractiveDebugger::findCommand | ( | std::string & | command | ) | const`[protected]`

virtual unsigned int BaseInteractiveDebugger::getStackSize | ( |  | ) | const`[pure virtual]`

void BaseInteractiveDebugger::interrupted | ( |  | ) | `[protected]`

void BaseInteractiveDebugger::listBreakPoints | ( |  | ) | const

virtual bool BaseInteractiveDebugger::outputCurrentFrame | ( | unsigned int | context = `0` | ) | const`[pure virtual]`

virtual void BaseInteractiveDebugger::outputCurrentFrameQueryPlan | ( |  | ) | const`[pure virtual]`

static void BaseInteractiveDebugger::outputLocation | ( | const XMLCh * | file,
|  | unsigned int | line,
|  | unsigned int | column,
|  | unsigned int | context = `0` |
| ) |  |  | `[static]`

static void BaseInteractiveDebugger::outputLocationFromString | ( | const XMLCh * | query,
|  | unsigned int | line,
|  | unsigned int | column,
|  | unsigned int | context = `0` |
| ) |  |  | `[static]`

virtual bool BaseInteractiveDebugger::queryCurrentFrame | ( | const char * | queryString | ) | const`[pure virtual]`

bool BaseInteractiveDebugger::queryStarted | ( |  | ) | const`[inline]`

void BaseInteractiveDebugger::readCommand | ( |  | ) | `[protected]`

static std::string BaseInteractiveDebugger::regexFind | ( | const char * | regex,
|  | const std::string & | str,
|  | int | groupNo = `1` |
| ) |  |  | `[static]`

virtual void BaseInteractiveDebugger::run | ( |  | ) | `[pure virtual]`

unsigned int BaseInteractiveDebugger::setBreakPoint | ( | const std::string & | file,
|  | unsigned int | line,
|  | unsigned int | column,
|  | bool | temporary |
| ) |  |  |

virtual void BaseInteractiveDebugger::setDoFocusOptimizationsn | ( | bool | opt | ) | `[pure virtual]`

virtual void BaseInteractiveDebugger::setDoLazyEvaluation | ( | bool | lazy | ) | `[pure virtual]`

virtual void BaseInteractiveDebugger::setDoProjection | ( | bool | opt | ) | `[pure virtual]`

void BaseInteractiveDebugger::setNext | ( |  | ) |

void BaseInteractiveDebugger::setStep | ( |  | ) |

virtual void BaseInteractiveDebugger::stackTrace | ( |  | ) | const`[pure virtual]`

## Member Data Documentation

std::vector<BreakPoint> BaseInteractiveDebugger::breaks_ `[protected]`

std::vector<DebugCommand*> BaseInteractiveDebugger::commands_ `[protected]`

unsigned int BaseInteractiveDebugger::next_ `[protected]`

DebugCommand* BaseInteractiveDebugger::prevcmd_ `[protected]`

bool BaseInteractiveDebugger::queryStarted_ `[protected]`

bool BaseInteractiveDebugger::step_ `[protected]`

The documentation for this class was generated from the following file:

- InteractiveDebugger.hpp